#!/usr/bin/env python

import sys
import os
from mmap import *
import struct, sstruct
import string
import types
import codecs
from romlib import *

def extractfile(file):
    fp = open(file.name,'wb+')
    # for executables the RomImageHeader is included
    if ( file.fileheader.iUid1 == 0x10000079) | ( file.fileheader.iUid1 == 0x1000007A):
        fp.write(file.file[file.iAddressLin - file.rom.iRomBase:file.iAddressLin - file.rom.iRomBase + file.iSize + TRomImageHeaderSize])
    else:
        fp.write(file.file[file.iAddressLin - file.rom.iRomBase:file.iAddressLin - file.rom.iRomBase + file.iSize])
    fp.close

def extractdir(romdir):
    print 'dir list ' + romdir.name
    os.mkdir(romdir.name)
    os.chdir(romdir.name)
    for file in romdir.dir:
        print '%10d 0x%0.8x 0x%0.2x %s'%(file.iSize,file.iAddressLin,file.iAtt,file.name)
        #print file.iNameLength
        if file.iAtt & 0x10:
            extractdir(file.romdir)
        else:
            extractfile(file)
    os.chdir('..')

# Main
if __name__ == '__main__':
    if len(sys.argv) < 2:
        print 'usage: %s filename' % sys.argv[0]
    else:
        rom= Rom(sys.argv[1])
    print 'iRomBase:\t\t0x%0.8x' % rom.iRomBase
    print 'iRomSize:\t\t0x%0.8x' % rom.iRomSize
    print 'iRomRootDirectoryList:\t0x%0.8x' % rom.iRomRootDirectoryList
    print 'iPrimaryFile:\t\t0x%0.8x' % rom.iPrimaryFile
    print 'iSecondaryFile:\t\t0x%0.8x' % rom.iSecondaryFile
    print 'iKernDataAddress:\t0x%0.8x' % rom.iKernDataAddress
    print 'iKernStackAddress:\t0x%0.8x' % rom.iKernStackAddress
    print 'iRomSectionHeader:\t0x%0.8x' % rom.iRomSectionHeader
    print 'iVariantFile:\t\t0x%0.8x' % rom.iVariantFile
    print 'iExtensionFile:\t\t0x%0.8x' % rom.iExtensionFile
    print 'iRelocInfo:\t\t0x%0.8x' % rom.iRelocInfo
    print 'iUserDataAddress:\t0x%0.8x' % rom.iUserDataAddress
    print 'iTotalUserDataSize:\t0x%0.8x' % rom.iTotalUserDataSize

    rootdirlist = RootDirList(rom, rom.iRomRootDirectoryList);
    print 'iNumRootDirs: 0x%0.8x' % rootdirlist.iNumRootDirs
   
    extractdir(rootdirlist.rootdirinfo.rootdir)

    rom.file.close()
