#!/usr/bin/env python

# Build data structures representing all information about files in an Extension ROM

import sys
import os
from mmap import *
import struct, sstruct
import string
import types
import codecs
from romlib import *

def myuniq(alist):
    set = {}
    map(set.__setitem__, alist, [])
    return set.keys()

def processdir(romdir, entrypoints):
    for file in romdir.dir:
        if file.iAtt & 0x10:
            processdir(file.romdir,entrypoints)
        else:
            if 'fileheader' in dir(file):
                if ( file.fileheader.iUid1 == 0x10000079) | ( file.fileheader.iUid1 == 0x1000007A):
                    entrypoints[file.fileheader.iEntryPoint] = file.name

def displaydir(romdir, entrypoints):
    for file in romdir.dir:
        if file.iAtt & 0x10:
            displaydir(file.romdir,entrypoints)
        else:
            if 'fileheader' in dir(file):
                if ( file.fileheader.iUid1 == 0x10000079) | ( file.fileheader.iUid1 == 0x1000007A):
#                print '\tiUids: 0x%0x, 0x%0x, 0x%0x'%(file.fileheader.iUid1,file.fileheader.iUid2,file.fileheader.iUid3)
                    print '%10d 0x%0.8x 0x%0.2x %s'%(file.iSize,file.iAddressLin,file.iAtt,file.name)
                    if (file.fileheader.iDllRefTable != 0):
#                    print 'DllRefTable 0x%08x'%file.fileheader.iDllRefTable
                        print '\t\tiNumberOfEntries: = %d'%file.dll.iNumberOfEntries
                        for i in range(file.dll.iNumberOfEntries):
                            print '\t\tdepends on: %08x'% file.dll.DllEntries[i].iEntryPoint
                            if entrypoints.has_key(file.dll.DllEntries[i].iEntryPoint):
                                print '\t\tdepends on: %s'% entrypoints[file.dll.DllEntries[i].iEntryPoint]
                            else:
                                print '\t\tdepends on: <UNKNOWN>'


# Main
if __name__ == '__main__':
    if len(sys.argv) < 2:
        print 'usage: %s filename' % sys.argv[0]
    else:
        rom= ExtensionRom(sys.argv[1])
    print 'iRomBase:\t\t0x%0.8x' % rom.iRomBase
    print 'iRomSize:\t\t0x%0.8x' % rom.iRomSize
    print 'iRomRootDirectoryList:\t0x%0.8x' % rom.iRomRootDirectoryList

    rootdirlist = RootDirList(rom, rom.iRomRootDirectoryList);
    print 'iNumRootDirs: 0x%0.8x' % rootdirlist.iNumRootDirs

    entrypoints = {}
    processdir(rootdirlist.rootdirinfo.rootdir, entrypoints)
    displaydir(rootdirlist.rootdirinfo.rootdir, entrypoints)
    rom.file.close()
