#!/usr/bin/env python

import sys
import os
import types
import re
from romlib import *
from struct import *

# Main
if __name__ == '__main__':
    if len(sys.argv) < 2:
        print 'usage: %s filename' % sys.argv[0]
    else:
        file = open(sys.argv[1],'rb')

    common = CommonHeader(file)
    if (common.iSignature == 0x434f5045):
        fileheader = E32ImageHeader(file)
    else:
        fileheader = RomImageHeader(file)

    print 'iUids: 0x%0x, 0x%0x, 0x%0x'%(fileheader.iUid1,fileheader.iUid2,fileheader.iUid3)

    for i in dir(fileheader):
        if re.match('^i.*',i):
            if (type(getattr(fileheader,i)) == types.IntType) | (type(getattr(fileheader,i)) == types.LongType):
                print '%20s:\t0x%0.8x'%(i, getattr(fileheader,i))

    sub = pack("<HHHH", 0x4b01, 0x681b, 0x4718, 0x46c0);
    file.seek(0)
    data = file.read()
    n = data.find(sub)
    while n>0:
        addr, = unpack("<L", data[n+8:n+12]);
        print "import addr = 0x%08x"% addr
        n = data.find(sub,n+12)
    sub = pack("<LL", 0xE59FC000, 0xE59Cf000);
    file.seek(0)
    data = file.read()
    n = data.find(sub)
    while n>0:
        addr, = unpack("<L", data[n+8:n+12]);
        print "import addr = 0x%08x"% addr
        n = data.find(sub,n+12)
    file.close()
