#!/usr/bin/env python

import sys
import os
from mmap import *
import struct, sstruct
import string
import types
import codecs
from romlib import *

def listdir(romdir):
    print 'dir list ' + romdir.name
    for file in romdir.dir:
        print '%10d 0x%0.8x 0x%0.2x %s'%(file.iSize,file.iAddressLin,file.iAtt,file.name)
        #print file.iNameLength
        if file.iAtt & 0x10:
            listdir(file.romdir)

# Main
if __name__ == '__main__':
    if len(sys.argv) < 2:
        print 'usage: %s filename' % sys.argv[0]
    else:
        rom= Rom(sys.argv[1])
    print 'iRomBase:\t\t0x%0.8x' % rom.iRomBase
    print 'iRomSize:\t\t0x%0.8x' % rom.iRomSize
    print 'iRomRootDirectoryList:\t0x%0.8x' % rom.iRomRootDirectoryList
    print 'iPrimaryFile:\t\t0x%0.8x' % rom.iPrimaryFile
    print 'iSecondaryFile:\t\t0x%0.8x' % rom.iSecondaryFile
    print 'iKernDataAddress:\t0x%0.8x' % rom.iKernDataAddress
    print 'iKernStackAddress:\t0x%0.8x' % rom.iKernStackAddress
    print 'iRomSectionHeader:\t0x%0.8x' % rom.iRomSectionHeader
    print 'iVariantFile:\t\t0x%0.8x' % rom.iVariantFile
    print 'iExtensionFile:\t\t0x%0.8x' % rom.iExtensionFile
    print 'iRelocInfo:\t\t0x%0.8x' % rom.iRelocInfo
    print 'iUserDataAddress:\t0x%0.8x' % rom.iUserDataAddress
    print 'iTotalUserDataSize:\t0x%0.8x' % rom.iTotalUserDataSize

    rootdirlist = RootDirList(rom, rom.iRomRootDirectoryList);
    print 'iNumRootDirs: 0x%0.8x' % rootdirlist.iNumRootDirs
   
    listdir(rootdirlist.rootdirinfo.rootdir)

    rom.file.close()
