#!/usr/bin/env python

# Create a nodes file for treeview

import sys
import os
from mmap import *
import struct, sstruct
import string
import types
import codecs
from romlib import *
import pickle


def myuniq(alist):
    set = {}
    map(set.__setitem__, alist, [])
    return set.keys()

def processdir(romdir, entrypoints):
    romdir.names = {}
    for file in romdir.dir:
        romdir.names[file.name.lower()] = file
        if file.iAtt & 0x10:
            processdir(file.romdir,entrypoints)
        else:
            if ( file.fileheader.iUid1 == 0x10000079) | ( file.fileheader.iUid1 == 0x1000007A):
                entrypoints[file.fileheader.iEntryPoint] = file.fullname()

def displaydir(romdir, parent, entrypoints):
    files = romdir.names.keys()
    files.sort()
    if parent is None:
        print >> nodesfile, 'D_%s = insFld(foldersTree, gFld("%s", "javascript:undefined"))'% (romdir.name,romdir.name)
    else:
        print >> nodesfile, 'D_%s = insFld(D_%s, gFld("%s", "javascript:undefined"))'% (romdir.name,parent,romdir.name)
    for name in files:
        file = romdir.names[name]
        if file.iAtt & 0x10:
            displaydir(file.romdir,romdir.name, entrypoints)
        else:
            print >> nodesfile, 'insDoc(D_%s, gLnk("R", "%s", "files/%s"))'%(romdir.name, file.name, file.fullname().replace('/','_')+'.html')
            htmlfile = open('files/'+file.fullname().replace('/','_')+'.html','w')
            #print file.fullname()
            print >> htmlfile, '<html>'
            print >> htmlfile, '<body>'
            print >> htmlfile, '<br><br>'
            print >> htmlfile, 'Full name: %s<br><br>'%file.fullname()
            print >> htmlfile, 'UID1: 0x%08x<br>'%file.fileheader.iUid1
            if ( file.fileheader.iUid1 == 0x10000079) | ( file.fileheader.iUid1 == 0x1000007A):
                print >> htmlfile, 'UID2: 0x%08x<br>'%file.fileheader.iUid2
                print >> htmlfile, 'UID3: 0x%08x<br>'%file.fileheader.iUid3
                if (file.fileheader.iDllRefTable != 0):
#                    print 'DllRefTable 0x%08x'%file.fileheader.iDllRefTable
#                    print '\t\tiNumberOfEntries: = %d'%file.dll.iNumberOfEntries
                    print >> htmlfile, '<br><b>Depends on:</b><br>'
                    for i in range(file.dll.iNumberOfEntries):
#                        print >> htmlfile, '\t\tdepends on: %08x<br>'% file.dll.DllEntries[i].iEntryPoint
                        if entrypoints.has_key(file.dll.DllEntries[i].iEntryPoint):
                            print >> htmlfile, '<a href="%s" target="basefrm">%s</a><br>'% (entrypoints[file.dll.DllEntries[i].iEntryPoint].replace('/','_')+'.html', entrypoints[file.dll.DllEntries[i].iEntryPoint])
                        else:
                            print >> htmlfile, 'depends on: &lt;UNKNOWN&gt;<br>'
                if importedbyname.has_key(file.name.lower()):
                    if len(importedbyname[file.name.lower()]) != 0:
                        print >> htmlfile, '<br><b>Imported by:</b><br>'
                        for name in importedbyname[file.name.lower()]:
                            print >> htmlfile, '<a href="%s" target="basefrm">%s</a><br>'% (name.replace('/','_')+'.html', name)
                if (file.fileheader.iExportDirCount != 0):
                    print >> htmlfile, '<br><b>Exports (%d ordinals):</b><br><br>'%file.fileheader.iExportDirCount
                    for export in range(file.fileheader.iExportDirCount):
                        if exports.byaddr.has_key(file.fileheader.iExportDir+export*4):
                            exportentry = exports.byaddr[file.fileheader.iExportDir+export*4]
                            if (len(importedbyaddr[file.fileheader.iExportDir+export*4]) > 0):
                                print >> htmlfile, '%10d:    <a href="%s" target="basefrm">%60s</a> ( 0x%08x )<br>'%(exportentry.ordinal,file.fullname().replace('/','_')+'_'+str(exportentry.ordinal)+'.html',exportentry.funcname,exportentry.funcaddr)
                                exportfile = open('files/'+file.fullname().replace('/','_')+'_'+str(exportentry.ordinal)+'.html','w')
                                print >> exportfile, '<html><body>'
                                print >> exportfile, 'The following files import %s:'%(exportentry.funcname)
                                filenames = importedbyaddr[file.fileheader.iExportDir+export*4]
                                filenames.sort()
                                for filename in filenames:
                                    print >> exportfile, '<a href="%s" target="basefrm">%s</a><br>'%(filename.replace('/','_')+'.html',filename)
                                print >> exportfile, '<br><a href="%s" target="basefrm">Back to main</a><br>'%(file.fullname().replace('/','_')+'.html')
                                print >> exportfile, '</body></html>'
                                exportfile.close()
                            else:
                                print >> htmlfile, '%10d:    %60s ( 0x%08x )<br>'%(exportentry.ordinal,exportentry.funcname,exportentry.funcaddr)
                            
                        else:
                            print "%s does not have export %d"%(file.name, export)

                if (file.fileheader.iDllRefTable != 0):
                    print >> htmlfile, '<br><b>Imports:</b><br><br>'
                    sub = struct.pack("<HHHH", 0x4b01, 0x681b, 0x4718, 0x46c0);
                    data = file.file[file.fileheader.address:file.fileheader.end+file.iSize]
                    n = data.find(sub)
                    while n>0:
                        addr, = struct.unpack("<L", data[n+8:n+12]);
                        #print >> htmlfile, "import addr = 0x%08x"% addr
                        if (exports.byaddr.has_key(addr)):
                            print >> htmlfile, "addr = 0x%08x %s<br>"%(addr,exports.byaddr[addr].funcname)
                        else:
                            print "cannot find %08x for %s"%(addr,file.name)
                        n = data.find(sub,n+12)
                    sub = struct.pack("<LL", 0xE59FC000, 0xE59Cf000);
                    n = data.find(sub)
                    while n>0:
                        addr, = struct.unpack("<L", data[n+8:n+12]);
                        #print >> htmlfile, "import addr = 0x%08x"% addr
                        if (exports.byaddr.has_key(addr)):
                            print >> htmlfile, "addr = 0x%08x %s<br>"%(addr,exports.byaddr[addr].funcname)
                        else:
                            print "cannot find %08x for %s"%(addr,file.name)
                        n = data.find(sub,n+12)



            print >> htmlfile, '<br>Size: %10d<br>'% file.iSize
            print >> htmlfile, 'Start Address: 0x%0.8x<br>'%file.iAddressLin

            if ((file.name[-4:] == '.txt') | (file.name[-4:] == '.ini') | (file.name[-4:] == '.esk')):
                print >> htmlfile, '<br><b>File contents:</b><br><br>'
                data = file.file[file.iAddressLin - file.rom.iRomBase:file.iAddressLin - file.rom.iRomBase + file.iSize]
                try:
                    data.encode('ascii')
                except UnicodeDecodeError:
#                    print 'UnicodeDecodeError: %s'%file.fullname()
                    utfreader = codecs.getreader('utf-16-le')
                    namereader = utfreader(file.file)
                    namereader.seek(file.iAddressLin - file.rom.iRomBase)
                    data = namereader.read(file.iSize)
                    data = data.encode('ascii','ignore')
                text = data.replace(chr(13),'<br>')
                htmlfile.write(text)

            print >> htmlfile, '</body>'
            print >> htmlfile, '</html>'
            htmlfile.close()

# Main
if __name__ == '__main__':
    if len(sys.argv) < 2:
        print 'usage: %s filename' % sys.argv[0]
    else:
        rom= Rom(sys.argv[1])

    filebyuid = pickle.load(open('filebyuid.db','r'))
    importedbyname = pickle.load(open('importedbyname.db','r'))
    importedbyaddr = pickle.load(open('importedbyaddr.db','r'))
    exports = pickle.load(open('exports.db','r'))

    try:
        os.chdir('html')
    except OSError, inst:
        print "error %d"%inst.errno
    
    try:
        os.mkdir('files')
    except OSError, inst:
        if inst.errno == 17:
            for root, dirs, files in os.walk('files', topdown=False):
                for name in files:
                    os.remove(os.path.join(root,name))
                for name in dirs:
                    os.rmdir(os.path.join(root, name))

    nodesfile = open('romNodes.js','w')

    rootdirlist = RootDirList(rom, rom.iRomRootDirectoryList);
    entrypoints = {}
    processdir(rootdirlist.rootdirinfo.rootdir, entrypoints)

    print >> nodesfile, """
//Environment variables are usually set at the top of this file.
USETEXTLINKS = 1
STARTALLOPEN = 0
USEFRAMES = 0
USEICONS = 1
WRAPTEXT = 1
PRESERVESTATE = 1
HIGHLIGHT = 1

foldersTree = gFld("<b>File System</b>", "index.html")

    """
    displaydir(rootdirlist.rootdirinfo.rootdir, None, entrypoints)
    rom.file.close()
    nodesfile.close()
