#
# Resolv imports and exports for a symbian ROM image
#
from idaapi import *
from idautils import *
from idc import *
import sys
import os
import string
import types
from romlib import *
import pickle
from struct import *

print "Starting..."

filename = AskFile(0,"exports.db","exports.db")
dir = os.path.dirname(filename)
os.chdir(dir)

importedbyaddr = pickle.load(open('importedbyaddr.db','r'))
exports = pickle.load(open('exports.db','r'))

# Get current ea
ea = get_screen_ea()

# Get segment class
seg = getseg(ea)

# iterate over the exports and rename them with our names
ord = 1
funcea = get_entry(ord)
while (funcea != BADADDR):
	if (exports.byfunc.has_key(get_name(BADADDR,funcea).lower())):
		export = exports.byfunc[get_name(BADADDR,funcea).lower()]
		if (export.funcaddr != funcea):
			print "Function mismatch: %x != %x"%(export.funcaddr, funcea)
        if (not export.mangled is None):
            if (not set_name(funcea, export.mangled,SN_CHECK)):
				print "set_name error occurred for %s"%export.mangled
            RenameEntryPoint(ord,export.mangled)
	else:
		print "Exported function %s (%x, %d) not found."%(get_name(BADADDR,funcea).lower(), funcea,ord)
	ord += 1
	funcea = get_entry(ord)

	
# search for the ARM mode import stub	
# if this triggers an error, it might be due to a bug in IDAPython 0.7.0
# get the patch from http://www.symternals.com/downloads.html
foundea = find_binary(seg.startEA, seg.endEA, "00 C0 9F E5 00 F0 9C E5", 16, SEARCH_DOWN|SEARCH_NOSHOW)
while (foundea != BADADDR):
	addr = get_long(foundea+8)
	if (not importedbyaddr.has_key(addr)):
		print "cannot find import for %08x"%(addr)
	if (exports.byaddr.has_key(addr)):
		print "addr = 0x%08x %s"%(addr,exports.byaddr[addr].funcname)
		# print "Mangled %s"%(exports.byaddr[addr].mangled)
		if (not set_name(foundea, exports.byaddr[addr].mangled,SN_CHECK)):
			print "set_name error occurred for %s"%exports.byaddr[addr].mangled		
	else:
		print "cannot find %08x for %s"%(addr,file.name)
	foundea = find_binary(foundea+4, seg.endEA, "00 C0 9F E5 00 F0 9C E5", 16, SEARCH_DOWN|SEARCH_NOSHOW)

# search for the THUMB mode import stub

foundea = find_binary(seg.startEA, seg.endEA, "01 4B 1B 68 18 47 C0 46", 16, SEARCH_DOWN|SEARCH_NOSHOW)
#print "found %x"%foundea
while (foundea != BADADDR):
	addr = get_long(foundea+8)
	if (not importedbyaddr.has_key(addr)):
		print "cannot find import for %08x"%(addr)
	if (exports.byaddr.has_key(addr)):
		print "addr = 0x%08x %s"%(addr,exports.byaddr[addr].funcname)
		# print "Mangled %s"%(exports.byaddr[addr].mangled)
		if (not set_name(foundea, exports.byaddr[addr].mangled,SN_CHECK)):
			print "set_name error occurred for %s"%exports.byaddr[addr].mangled		
	else:
		print "cannot find %08x for %s"%(addr,file.name)
	foundea = find_binary(foundea+4, seg.endEA, "01 4B 1B 68 18 47 C0 46", 16, SEARCH_DOWN|SEARCH_NOSHOW)
	

